package net.minecraft.src;

public abstract class EntityNameplateBase extends Entity
{
    public EntityLiving entityOwner;
    public String petName;
    public String ownerClass;
    public int maidColor;
    public long maidUniqueID = 0L;
    protected int OwnerFinding = 0;

    protected abstract boolean setOwnerEntity(EntityLiving var1);

    protected abstract EntityLiving FindOwner();

    public static EntityNameplateBase CreateNameplate(World world, EntityLiving owner)
    {
        String var2 = owner.getEntityString();
        //return (EntityNameplateBase)(var2 == "Wolf" ? new EntityNameplate(world, owner) : (mod_Nameplate.isLMMEnable && var2 == "LittleMaid" ? new EntityNameplateMaid(world, owner) : null));
        return (EntityNameplateBase)(var2 == "Wolf" ? new EntityNameplate(world, owner) : null);
    }

    protected EntityNameplateBase(World world)
    {
        super(world);
    }

    public void entityInit()
    {
        if (this.entityOwner == null)
        {
            if (!this.setOwnerEntity(this.FindOwner()))
            {
                ++this.OwnerFinding;

                if (this.OwnerFinding > 120)
                {
                    this.setDead();
                }

                return;
            }

            System.out.println(String.format("found nearest owner, owner id = %d", new Object[] {Integer.valueOf(this.entityOwner.entityId)}));
        }

        if (this.entityOwner.isDead)
        {
            this.setDead();
        }
        else
        {
            this.setPosition(this.entityOwner.posX, this.entityOwner.posY, this.entityOwner.posZ);
        }
    }

    protected void writeEntityToNBT(NBTTagCompound nbttagcompound) {}

    protected void readEntityFromNBT(NBTTagCompound nbttagcompound)
    {
        this.petName = nbttagcompound.getString("Name");
        this.posX = nbttagcompound.getDouble("OwnerX");
        this.posY = nbttagcompound.getDouble("OwnerY");
        this.posZ = nbttagcompound.getDouble("OwnerZ");
        this.maidColor = nbttagcompound.getInteger("MaidColor");
        this.maidUniqueID = nbttagcompound.getLong("MaidUniqueID");
    }
}
