package net.minecraft.src;

import net.minecraft.client.Minecraft;
import net.minecraft.src.forge.*;

public class ItemNameplate extends Item implements ITextureProvider, IEntityInteractHandler
{
    public ItemNameplate(int id, int icon)
    {
        super(id);
        setIconIndex(icon);
        this.maxStackSize = 64;
    }

    public ItemStack onItemRightClick(ItemStack item, World world, EntityPlayer player)
    {
        Minecraft minecraft = ModLoader.getMinecraftInstance();

        if (minecraft.objectMouseOver == null)
        {
            return item;
        }
        /*
        else if (minecraft.objectMouseOver.vertexPositions != EntityPlayer.spawnChunk)
        {
            return item;
        }
        */
        else if(mod_Nameplate.EntityNameable(minecraft.objectMouseOver.entityHit))
        {
            if (mod_Nameplate.isJPInputEnable)
            {
                //ModLoader.openGUI(player, new GuiPetRenameJP(world, player, (EntityLiving)minecraft.objectMouseOver.entityHit, item));
            }
            else
            {
                ModLoader.openGUI(player, new GuiPetRename(world, player, (EntityLiving)minecraft.objectMouseOver.entityHit, item));
            }

            if(minecraft.objectMouseOver.entityHit instanceof EntityTameable)
            {
                boolean isSitting = ((EntityTameable)minecraft.objectMouseOver.entityHit).isSitting();
                //System.out.println(String.format("isSitting=%s", new Object[] { Boolean.toString(isSitting) }));
                ((EntityTameable)minecraft.objectMouseOver.entityHit).setSitting(!isSitting);
            }

            return item;
        }

        return item;
    }

    public String getTextureFile()
    {
        return mod_Nameplate.itemsPng;
    }

    public boolean onEntityInteract(EntityPlayer player, Entity entity, boolean isAttack)
    {
        if(entity instanceof EntityTameable)
        {
            System.out.println("onEntityInteract");
            boolean isSitting = ((EntityTameable)entity).isSitting();
            System.out.println(String.format("isSitting=%s", new Object[] { Boolean.toString(isSitting) }));
        }
        
        return true;
    }
}
