package net.minecraft.src;

import java.lang.reflect.Method;
import java.util.Map;

import net.minecraft.src.forge.*;

public class mod_Nameplate extends BaseMod
{
    public static String itemsPng = "/Nameplate/icon.png";

    public static Item npItem;
    public static boolean isLMMEnable = false;
    public static boolean isJPInputEnable = false;
    public static int NameplateColor = -1;
    public static int NameplateBkgnd = 0;
    @MLProp(
            name = "ShowDistance"
    )
    public static double ShowDistance = 20.0D;
    @MLProp(
            name = "CraftQuantity"
    )
    public static int CraftQuantity = 4;
    @MLProp(
            name = "Height"
    )
    public static double NameplateHeight = 0.5D;
    @MLProp(
            name = "TextColor"
    )
    public static String strTextColor = "-1";
    @MLProp(
            name = "Background"
    )
    public static String strBkgndColor = "0";
    @MLProp(
            name = "Scale"
    )
    public static double NameplateScale = 1.0D;
    @MLProp(
            name = "ItemID"
    )
    public static int itemID = 27840;
    static Class class$EntityNameplate;
    static Class class$EntityNameplateMaid;

    public String getVersion()
    {
        return "1.2.5-1";
    }

    public void load()
    {
        MinecraftForgeClient.preloadTexture(itemsPng);

        try
        {
            // 文字色の解析
            if (strTextColor.startsWith("0x"))
            {
                strTextColor = "00000000" + strTextColor.substring(2);
                strTextColor = strTextColor.substring(strTextColor.length() - 8);
                NameplateColor = Integer.parseInt(strTextColor.substring(0, 4), 16) << 16 | Integer.parseInt(strTextColor.substring(4, 8), 16);
            }
            else
            {
                NameplateColor = Integer.parseInt(strTextColor);
            }

            // 背景色の解析
            if (strBkgndColor.startsWith("0x"))
            {
                strBkgndColor = "00000000" + strBkgndColor.substring(2);
                strBkgndColor = strBkgndColor.substring(strBkgndColor.length() - 8);
                NameplateBkgnd = Integer.parseInt(strBkgndColor.substring(0, 4), 16) << 16 | Integer.parseInt(strBkgndColor.substring(4, 8), 16);
            }
            else
            {
                NameplateBkgnd = Integer.parseInt(strBkgndColor);
            }
        }
        catch (Exception ex)
        {
            System.out.println("Nameplate:Exception is occurred in load.");
            System.out.println(ex.toString());
        }

        // Entityの登録 {
            ModLoader.registerEntityID(
                class$EntityNameplate == null
                ? (class$EntityNameplate = class$("net.minecraft.src.EntityNameplate"))
                : class$EntityNameplate, "Nameplate", ModLoader.getUniqueEntityId()
            );
            
            try
            {
                Class var1 = Class.forName("mod_littleMaidMob");

                if (var1 != null)
                {
                    System.out.println("mod:LittleMaidMob found.");
                    isLMMEnable = true;
                    
                    ModLoader.registerEntityID(
                        class$EntityNameplateMaid == null
                        ? (class$EntityNameplateMaid = class$("net.minecraft.src.EntityNameplateMaid"))
                        : class$EntityNameplateMaid, "NameplateForMaid", ModLoader.getUniqueEntityId()
                    );
                }
                else
                {
                    System.out.println("cannot find mod_littlemaidmob");
                    isLMMEnable = false;
                }
            }
            catch (Exception var3)
            {
                System.out.println("cannot find mod_littlemaidmob");
                isLMMEnable = false;
            }
        // }
        
        // Itemの登録 {
            npItem = (new ItemNameplate(itemID, 0)).setItemName("Nameplate");
            //npItem.iconIndex  = ModLoader.addOverride("/gui/items.png", "/Nameplate/icon.png");
            ModLoader.addName(npItem, "Name plate");
            ModLoader.addShapelessRecipe(
                new ItemStack(npItem, CraftQuantity),
                new Object[] {
                    new ItemStack(Item.ingotIron, 1),       // 鉄インゴット
                    new ItemStack(Item.dyePowder, 1, 0),    // イカ墨
                    new ItemStack(Item.silk, 1)             // 糸
                }
            );
        // }

        //MinecraftForge.registerEntityInteractHandler((ItemNameplate)npItem);
    }

    public void ModsLoaded()
    {
        Class var1;

        try
        {
            var1 = Class.forName("mod_RequestFocus");

            if (var1 != null)
            {
                System.out.println("mod:MinecraftIM found.");
                isJPInputEnable = true;
            }
            else
            {
                System.out.println("cannot find MinecraftIM");
                isJPInputEnable = false;
            }
        }
        catch (Exception var2)
        {
            System.out.println("cannot find MinecraftIM");
            isJPInputEnable = false;
        }
    }

    public void addRenderer(Map mapcls)
    {
        mapcls.put(class$EntityNameplate == null ? (class$EntityNameplate = class$("net.minecraft.src.EntityNameplate")) : class$EntityNameplate, new RenderNameplate());
        if(isLMMEnable)
        {
            mapcls.put(class$EntityNameplateMaid == null ? (class$EntityNameplateMaid = class$("net.minecraft.src.EntityNameplateMaid")) : class$EntityNameplateMaid, new RenderNameplate());
        }
    }

    static Class class$(String var0)
    {
        try
        {
            return Class.forName(var0);
        }
        catch (ClassNotFoundException var2)
        {
            throw new NoClassDefFoundError(var2.getMessage());
        }
    }
    
    // MODが命名できるEntityかどうかを返す
    static boolean EntityNameable(Object entity)
    {
        if(isLMMEnable && entity instanceof EntityLittleMaid)
        {
            if(((EntityLittleMaid)entity).isMaidContract())
            {
                //System.out.println(String.format("Entity %d[%s] is nameable.", new Object[] { ((Entity)entity).entityId, ((Entity)entity).getEntityString() }));
                return true;
            }
        }
        else if(entity instanceof EntityTameable)
        {
            if(((EntityTameable)entity).isTamed())
            {
                //System.out.println(String.format("Entity %d[%s] is nameable.", new Object[] { ((Entity)entity).entityId, ((Entity)entity).getEntityString() }));
                return true;
            }
        }
        else if(entity instanceof EntityLiving)
        {
            try
            {
                Method m = entity.getClass().getMethod("isTamed");
                if(((Boolean)m.invoke(entity, new Object[] {})).booleanValue())
                {
                    //System.out.println(String.format("Entity %d[%s] is nameable.", new Object[] { ((Entity)entity).entityId, ((Entity)entity).getEntityString() }));
                    return true;
                }
            }
            catch(Exception ex) { }
        }
        
        return false;
    }
}
